package jdbc;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class Main {

    public static void main(String[] args) {
        Connection connection = null;
        Statement statement = null;
        try {
            //musime prinutit nahrat tridu do JVM, aby se zaregistroval driver
            Class.forName("org.sqlite.JDBC");

            //za posledni dvojteckou lze specifikovat i absolutni cestu
            connection = DriverManager.getConnection("jdbc:sqlite:psi.sqlite");

            //statement - pro jednoduche dotazy
            statement = connection.createStatement();
            statement.setQueryTimeout(30);

            ResultSet res = statement.executeQuery("Select id, jmeno,majitel from Pes;");
            while(res.next()){
                System.out.println(String.format("%2d, %s, %s", res.getInt("id"), res.getString(2), res.getString(3)));
            }
            res.close();

            System.out.println("---");

            res = statement.executeQuery("select id, jmeno from pes where majitel like 'Novak';");
            while(res.next()){
                System.out.println(String.format("%2d, %s", res.getInt("id"), res.getString(2)));
            }
            res.close();

            System.out.println("---");

            int pocet = statement.executeUpdate(
                    "update pes set majitel = 'Cermak' where jmeno = 'Azor'");
            System.out.println(String.format("Modifikovano %d zaznamu", pocet));

            System.out.println("---");

            PreparedStatement prepared = connection.prepareStatement("select id, jmeno, majitel from pes where majitel like ?");
            prepared.setString(1, "%ak");
            res = prepared.executeQuery();
            while(res.next()){
                System.out.println(String.format("%2d, %s, %s", res.getInt("id"), res.getString(2), res.getString(3)));
            }
            res.close();
            prepared.close();
            statement.close();

        } catch (ClassNotFoundException ex) {
            System.out.println("SQLite driver nenalezen");
        } catch (SQLException e) {
            // if the error message is "out of memory",
            // it probably means no database file is found
            System.err.println(e.getMessage());
        } finally {
            try {
                if (connection != null) {
                    connection.close();
                }
            } catch (SQLException e) {
                // connection close failed.
                System.err.println(e);
            }
        }
    }
}
